
#include "Menu.h"

extern void MenuBarCB();

/* Button Types */
#define  PushButton    0
#define  ToggleButton  1

Widget CreateMenuBar (parent)
     Widget  parent;
{
  Widget  menuBar;
  Widget  cascade;
  Widget  pulldownPane;
  Widget  button;

  Arg		al[10];		/*  arg list		*/
  register int	ac;		/*  arg count		*/


  /* Create menu bar. */
  ac = 0;
  menuBar = XmCreateMenuBar (parent, "menuBar", al, ac);

  /************************************************************
                            F i l e
   ************************************************************/

  ac = 0;
  pulldownPane = XmCreatePulldownMenu (menuBar, "pulldownPane", al, ac);

  CreateMenuButton (pulldownPane, NULL, MENU_File_New, PushButton, 
		    "New ...", 'N', NULL, NULL);
  CreateMenuButton (pulldownPane, NULL, MENU_File_Open, PushButton, 
		    "Open ...", 'O', NULL, NULL);

  AddSeparator(pulldownPane);

  CreateMenuButton (pulldownPane, NULL, MENU_File_Save, PushButton, 
		    "Save", 'S', NULL, NULL);
  CreateMenuButton (pulldownPane, NULL, MENU_File_SaveAs, PushButton, 
		    "Save As ...", 'A', NULL, NULL);

  AddSeparator(pulldownPane);

  CreateMenuButton (pulldownPane, NULL, MENU_File_Print, PushButton, 
		    "Print ...", 'P', NULL, NULL);

  AddSeparator(pulldownPane);

  CreateMenuButton (pulldownPane, NULL, MENU_File_Exit, PushButton, 
		    "Exit", 'E', "Meta<Key>F4:", "Meta+F4");

  CreateMenuButton (menuBar, 

  /***   File cascade button   ****/
  ac = 0;
  XtSetArg (al[ac], XmNsubMenuId, pulldownPane);  ac++;
  XtSetArg (al[ac], XmNlabelString, String("File")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'F'); ac++;
  cascade= XmCreateCascadeButton (menuBar, NULL, al, ac);
  XtManageChild (cascade);

  /************************************************************
	                    E d i t
   ************************************************************/

  ac = 0;
  pulldownPane = XmCreatePulldownMenu (menuBar, "pulldownPane", al, ac);

  /***   XXX   ***/



  /***   Entities ...   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Entities ...")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'E'); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(button, XmNactivateCallback, MenuBarCB, MENU_Edit_Entities);
  XtManageChild (button);

  /***   Callouts ...   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Callouts ...")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'C'); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(button, XmNactivateCallback, MenuBarCB, MENU_Edit_Callouts);
  XtManageChild (button);

  /*** Separator ***/
  AddSeparator(pulldownPane);
  
  /***   Select all   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Select all")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'S'); ac++;
  XtSetArg (al[ac], XmNacceleratorText, String("^S")); ac++;
  XtSetArg (al[ac], XmNaccelerator, "Ctrl<Key>S:"); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(button, XmNactivateCallback, MenuBarCB, MENU_Edit_SelectAll);
  XtManageChild (button);

  /***   Unselect all   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Unselect all")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'U'); ac++;
  XtSetArg (al[ac], XmNacceleratorText, String("^U")); ac++;
  XtSetArg (al[ac], XmNaccelerator, "Ctrl<Key>U:"); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(button, XmNactivateCallback, MenuBarCB, MENU_Edit_UnselectAll);
  XtManageChild (button);
  
  /***   Edit cascade button   ****/
  ac = 0;
  XtSetArg (al[ac], XmNsubMenuId, pulldownPane);  ac++;
  XtSetArg (al[ac], XmNlabelString, String("Edit")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'E'); ac++;
  cascade = XmCreateCascadeButton (menuBar, NULL, al, ac);
  XtManageChild (cascade);

  /************************************************************
         	          O p t i o n s
   ************************************************************/

  ac = 0;
  pulldownPane = XmCreatePulldownMenu (menuBar, "pulldownPane", al, ac);





  /***   Options cascade button   ****/
  ac = 0;
  XtSetArg (al[ac], XmNsubMenuId, pulldownPane);  ac++;
  XtSetArg (al[ac], XmNlabelString, String("Options")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'O'); ac++;
  optionsCascade = XmCreateCascadeButton (menuBar, NULL, al, ac);
  XtManageChild (optionsCascade);


  /************************************************************
           	        S e t t i n g s
   ************************************************************/

  ac = 0;
  pulldownPane = XmCreatePulldownMenu (menuBar, "pulldownPane", al, ac);

  /***   Search paths ...   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Search paths ...")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'S'); ac++;
  XtSetArg (al[ac], XmNentryAlignment, XmALIGNMENT_BEGINNING); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback (button,XmNactivateCallback,
		 HPTagDialogMenuBarCB, TAG_MENU_Search);
  XtManageChild (button);

  searchPath_editor = CreateSearchPathEditor(pulldownPane);

  /***   Editor ...   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Editor ...")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'E'); ac++;
  XtSetArg (al[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback (button, XmNactivateCallback,
		 MenuBarCB, MENU_Settings_Editor);
  XtManageChild (button);

  editor_dialog = CreateEditorDialog(pulldownPane);

  /*** Separator ***/
  AddSeparator(pulldownPane);

  /***   Character set (label)   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Character set:")); ac++;
  XtSetArg (al[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
  button = XmCreateLabelGadget (pulldownPane, NULL, al, ac);
  XtManageChild (button);

  /***   Roman 8   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Roman 8")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'R'); ac++;
  XtSetArg (al[ac], XmNset, True); ac++;
  XtSetArg (al[ac], XmNindicatorType, XmONE_OF_MANY); ac++;
  roman8Toggle = XmCreateToggleButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(roman8Toggle,XmNvalueChangedCallback,
		HPTagDialogMenuBarCB, TAG_MENU_Roman8);
  XtManageChild (roman8Toggle);

  /***   PC 8   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("PC 8")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'P'); ac++;
  XtSetArg (al[ac], XmNindicatorType, XmONE_OF_MANY); ac++;
  pc8Toggle = XmCreateToggleButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(pc8Toggle,XmNvalueChangedCallback,
		HPTagDialogMenuBarCB, TAG_MENU_PC8);
  XtManageChild (pc8Toggle);
  
  /***   PC 8 DN   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("PC 8 DN")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'D'); ac++;
  XtSetArg (al[ac], XmNindicatorType, XmONE_OF_MANY); ac++;
  pc8dnToggle = XmCreateToggleButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(pc8dnToggle,XmNvalueChangedCallback,
		HPTagDialogMenuBarCB, TAG_MENU_PC8DN);
  XtManageChild (pc8dnToggle);
  
  /***   Asian   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Asian")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'A'); ac++;
  XtSetArg (al[ac], XmNindicatorType, XmONE_OF_MANY); ac++;
  button = XmCreateToggleButtonGadget (pulldownPane, NULL, al, ac);
  XtManageChild (button);
  
  /*** Separator ***/
  AddSeparator(pulldownPane);
  
  /***   Save Level (label)   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Save level:")); ac++;
  XtSetArg (al[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
  button = XmCreateLabelGadget (pulldownPane, NULL, al, ac);
  XtManageChild (button);
  
  /***  Raw (Printer file)   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("HP PCL")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'H'); ac++;
  XtSetArg (al[ac], XmNset, True); ac++;
  rawToggle = XmCreateToggleButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(rawToggle,XmNvalueChangedCallback,
		HPTagDialogMenuBarCB, TAG_MENU_SaveRaw);
  XtManageChild (rawToggle);
  

  /***  DVI   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("DVI")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'D'); ac++;
  XtSetArg (al[ac], XmNset, True); ac++;
  dviToggle = XmCreateToggleButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(dviToggle,XmNvalueChangedCallback,
		HPTagDialogMenuBarCB, TAG_MENU_SaveDVI);
  XtManageChild (dviToggle);
  
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("TeX")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'T'); ac++;
  XtSetArg (al[ac], XmNset, True); ac++;
  texToggle = XmCreateToggleButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(texToggle,XmNvalueChangedCallback,
		HPTagDialogMenuBarCB, TAG_MENU_SaveTeX);
  XtManageChild (texToggle);

  /***  None   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("None")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'N'); ac++;
  XtSetArg (al[ac], XmNset, True); ac++;
  noneToggle = XmCreateToggleButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback(noneToggle,XmNvalueChangedCallback,
		HPTagDialogMenuBarCB,TAG_MENU_SaveNone);
  XtManageChild (noneToggle);
  
  /***   Settings cascade button   ****/
  ac = 0;
  XtSetArg (al[ac], XmNsubMenuId, pulldownPane);  ac++;
  XtSetArg (al[ac], XmNlabelString, String("Settings"));  ac++;
  XtSetArg (al[ac], XmNmnemonic, 'S'); ac++;
  settingsCascade = XmCreateCascadeButton (menuBar, NULL, al, ac);
  XtManageChild (settingsCascade);


  /************************************************************
	                   H e l p     
   ************************************************************/

  ac = 0;
  pulldownPane = XmCreatePulldownMenu (menuBar, "pulldownPane", al, ac);

  /***   On Item ...   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("On Item ...")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'I'); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtManageChild (button);
  
  /***   On Application ...   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("On Application ...")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'A'); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtManageChild (button);
  
  /***   On Help ...   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("On Help ...")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'H'); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtManageChild (button);
	
  /***   On Version ...	***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("On Version ...")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'V'); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback (button,XmNactivateCallback,MenuBarCB, 
		 MENU_Help_AboutLeProCon);
  XtManageChild (button);
  
  /*** Separator ***/
  AddSeparator(pulldownPane);
  
  /***   Tutorial ...   ***/
  ac = 0;
  XtSetArg (al[ac], XmNlabelString, String("Tutorial ...")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'T'); ac++;
  button = XmCreatePushButtonGadget (pulldownPane, NULL, al, ac);
  XtAddCallback (button,XmNactivateCallback,MenuBarCB, 
		 MENU_Help_GettingStarted);
  XtManageChild (button);
  
  /***   Help cascade button   ****/
  ac = 0;
  XtSetArg (al[ac], XmNsubMenuId, pulldownPane);  ac++;
  XtSetArg (al[ac], XmNlabelString, String("Help")); ac++;
  XtSetArg (al[ac], XmNmnemonic, 'H'); ac++;
  cascade = XmCreateCascadeButton (menuBar, NULL, al, ac);
  XtManageChild (cascade);

  /***   Make Help button right-justified in menu bar   ***/
  ac = 0;
  XtSetArg (al[ac], XmNmenuHelpWidget, cascade); ac++;
  XtSetValues(menuBar, al, ac);
  
  return(menuBar);

}


/******************************************************************************
                    A d d   B u t t o n   U t i l i t y
******************************************************************************/

static Widget CreateMenuButton(parent, name, buttonID, buttonType,
			    buttonLabelStr, buttonMnemonic, 
			    buttonAccelerator, buttonAcceleratorText)
     Widget  parent;
     char    *name;
     int     buttonID;
     int     buttonType;
     char    *buttonLabelStr;
     char    buttonMnemonic;
     char    *buttonAccelerator;
     char    *buttonAcceleratorTextStr;
{
  Arg  al[5];
  int  ac;

  XmString  buttonLabel;
  XmString  buttonAcceleratorText;

  buttonLabel = 
    XmStringLtoRCreate(buttonLabelStr, XmSTRING_DEFAULT_CHARSET);
  buttonAcceleratorText = 
    XmStringLtoRCreate(buttonAcceleratorTextStr, XmSTRING_DEFAULT_CHARSET);

  ac = 0;
  XtSetArg (al[ac], XmNlabelString, buttonLabel); ac++;
  XtSetArg (al[ac], XmNmnemonic, buttonMnemonic); ac++;
  if (strlen(buttonAccelerator) > 0)
    XtSetArg (al[ac], XmNaccelerator, buttonAccelerator); ac++;
  if (strlen(buttonAcceleratorTextStr) > 0)
    XtSetArg (al[ac], XmNacceleratorText, buttonAcceleratorText); ac++;

  if (buttonType == CascadeButton)
    {
      button = XmCreateCascadeButtonGadget (parent, NULL, al, ac);
    }
  else if (buttonType == ToggleButton)
    {
      button = XmCreateToggleButtonGadget (parent, NULL, al, ac);
      XtAddCallback(button, XmNvalueChangedCallback, MenuBarCB, buttonID);
    }
  else /* Create a push button by default. */
    {
      button = XmCreatePushButtonGadget (parent, NULL, al, ac);
      XtAddCallback(button, XmNactivateCallback, MenuBarCB, buttonID);
    }
  XtManageChild (button);

  XmStringFree (buttonLabel);
  XmStringFree (buttonAcceleratorText);

  return (button);

}



/******************************************************************************
                   A d d   S e p a r a t o r   U t i l i t y
******************************************************************************/

static AddSeparator(parent)
     Widget parent;
{
  Widget separator;
  Arg    al[10];
  int    ac;
  
  ac = 0;
  separator = XmCreateSeparatorGadget (parent, NULL, al, ac);
  XtManageChild (separator);
}

